using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Bullet : MonoBehaviour
{
    [SerializeField] float m_expireTime = 2;
    [SerializeField] float m_speed = 20;
    [SerializeField] Vector3 m_moveDirection = new Vector3(0, 1, 0);
    uint m_timerId;

    private void OnEnable()
    {
        m_timerId = Timer_Manager.AddTimer(gameObject, Expire, m_expireTime);
    }

    private void OnDisable()
    {
        Timer_Manager.CancelTimer(m_timerId);
    }

    void Update()
    {
        transform.position += (transform.rotation * m_moveDirection) * m_speed * Time.deltaTime;
    }

    void Expire()
    {
        gameObject.SetActive(false);
    }

    private void OnDestroy()
    {
        Timer_Manager.CancelTimer(m_timerId);
    }
}
