using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

[CreateAssetMenu(fileName = "Data", menuName = "ScriptableObjects/BulletPrefabPoolData", order = 1)]
public class BulletPoolData : ScriptableObject
{
    [SerializeField] GameObject m_bulletPrefab;
    [SerializeField] int m_bulletPoolSize = 200;
    private PrefabPool m_prefabPool;

    public PrefabPool PrefabPool
    {
        get 
        { 
            if(m_prefabPool == null)
            {
                m_prefabPool = new PrefabPool(m_bulletPrefab, m_bulletPoolSize);
            }
            return m_prefabPool; 
        }
    }

    public void Reset()
    {
        m_prefabPool?.Clear();
        m_prefabPool = new PrefabPool(m_bulletPrefab, m_bulletPoolSize);
    }

    private void OnDisable()
    {
        m_prefabPool = null;
    }
}
