using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Enemy_PatternController : MonoBehaviour
{
    public event System.Action OnPatternEnd;
    [SerializeField] GameObject m_patternParent;
    [SerializeField] List<PatternStep> m_patternSteps;
    [SerializeField] GameObject m_currentStep;
    int step = 0;

    public void StartPattern()
    {
        m_patternSteps = new List<PatternStep>(m_patternParent.GetComponentsInChildren<PatternStep>());
        m_patternSteps[step].StartStep(NextStep);
    }

    public void PatternEnd()
    {
        OnPatternEnd?.Invoke();
    }

    public void NextStep()
    {
        step++;
        if (step < m_patternSteps.Count)
        {
            m_currentStep = m_patternSteps[step].gameObject;
            m_patternSteps[step].StartStep(NextStep);
        }
        else
        {
            PatternEnd();
        }
    }
}


