using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using MEC;

public class AnyKey : Prompts
{
    [SerializeField] AvailableKeys m_availableKeys;
    CoroutineHandle m_cHandle;

    public override void StartPrompt(Action<bool, int> callback)
    {
        m_promptUIObject?.SetActive(true);
        m_cHandle = Timing.RunCoroutine(WaitForKey(callback).CancelWith(gameObject));
    }

    IEnumerator<float> WaitForKey(Action<bool, int> callback)
    {
        bool pressedKey = false;
        while (!pressedKey)
        {
            foreach (var key in m_availableKeys.m_availableKeys)
            {
                if (Input.GetKey(key))
                {
                    pressedKey = true;
                    break;
                }
            }
            yield return Timing.WaitForOneFrame;
        }
        m_promptUIObject.SetActive(false);
        callback(true, m_points);
    }

    public override void CancelPrompt()
    {
        m_promptUIObject.SetActive(false);
        Timing.KillCoroutines(m_cHandle);
    }
}
