using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;
using MEC;
using TMPro;

public class DontPressKey : Prompts
{
    [SerializeField] AvailableKeys m_availableKeys;
    [SerializeField] TextMeshProUGUI m_notSelectKeyText;
    CoroutineHandle m_cHandle;
    string selectedKey;

    public override void StartPrompt(Action<bool, int> callback)
    {
        m_promptUIObject.SetActive(true);
        int select = UnityEngine.Random.Range(0, m_availableKeys.m_availableKeys.Count);
        string key = m_availableKeys.m_availableKeys[select];
        m_notSelectKeyText.text = key.ToUpper();

        m_cHandle = Timing.RunCoroutine(
            WaitForKey(callback, key)
            .CancelWith(gameObject));
    }

    IEnumerator<float> WaitForKey(Action<bool, int> callback, string keyToPress)
    {
        bool pressedKey = false;
        bool succeed = false;
        while (!pressedKey)
        {
            foreach (var key in m_availableKeys.m_availableKeys)
            {
                bool thisKey = Input.GetKeyDown(key);
                if (thisKey && key != keyToPress)
                {
                    pressedKey = true;
                    succeed = true;
                    break;
                }
                else if (thisKey && key == keyToPress)
                {
                    pressedKey = true;
                    break;
                }
            }
            yield return Timing.WaitForOneFrame;
        }
        m_promptUIObject.SetActive(false);
        callback(succeed, m_points);
    }

    public override void CancelPrompt()
    {
        m_promptUIObject.SetActive(false);
        Timing.KillCoroutines(m_cHandle);
    }
}
