using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ShipLaser : MonoBehaviour
{

    [SerializeField] GameObject m_laserBeam;
    [SerializeField] GameObject m_warningPath;
    [SerializeField] float m_laserTime = 1.5f;

    public void Prepare()
    {
        m_warningPath.SetActive(true);
        m_laserBeam.SetActive(false);
    }

    public void HideWarning()
    {
        m_warningPath.SetActive(false);
    }

    public void Fire()
    {
        m_warningPath.SetActive(false);
        m_laserBeam.SetActive(true);

        Timer_Manager.AddTimer(gameObject, () =>
        {
            m_warningPath.SetActive(false);
            m_laserBeam.SetActive(false);
        }, m_laserTime);
    }

}
