using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class UI_HealthDisplay : MonoBehaviour
{
    [SerializeField] PS_Health m_playerHealth;
    [SerializeField] List<GameObject> fullHealthBits;

    // Start is called before the first frame update
    void Start()
    {
        m_playerHealth.OnHealthChange += PlayerHealth_OnHealthChange;
        SetHealthDisplay(m_playerHealth.ShipHealth);
    }

    private void PlayerHealth_OnHealthChange(int obj)
    {
        SetHealthDisplay(obj);
    }

    void SetHealthDisplay(int health)
    {
        for (int i = 0; i < fullHealthBits.Count; i++)
        {
            if(health >= i+1)
            {
                fullHealthBits[i].SetActive(true);
            }
            else
            {
                fullHealthBits[i].SetActive(false);
            }
        }
    }
}
