using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Wave_Enemy : MonoBehaviour
{
    List<Enemy_PatternController> m_enemyShips = new List<Enemy_PatternController>();
    int m_shipCount;
    [SerializeField]bool m_startAutomatically = false;

    // Start is called before the first frame update
    private void Start()
    {
        if(m_startAutomatically)
        {
            StartWave();
        }
    }

    public void StartWave()
    {
        m_shipCount = m_enemyShips.Count;
        m_enemyShips = new List<Enemy_PatternController>(GetComponentsInChildren<Enemy_PatternController>());
        
        m_enemyShips.ForEach((x) =>
        {
            x.OnPatternEnd += ShipAnimEnded;
            x.StartPattern();
        });
    }

    void ShipAnimEnded()
    {
        m_shipCount--;

        if(m_shipCount <= 0)
        {
            Destroy(gameObject);
        }
    }
}
