using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Wave_Spawner : MonoBehaviour
{
    [SerializeField] bool b_startAutomatically = false;
    [SerializeField] Wave_Sequence m_sequence;
    List<uint> m_timerIds = new List<uint>();

    public void Start()
    {
        if(b_startAutomatically)
        {
            StartSequence();
        }
    }

    public void StartSequence()
    {
        for (int i = 0; i < m_sequence.m_wavePrefabs.Count; i++)
        {
            var go = Instantiate(m_sequence.m_wavePrefabs[i], gameObject.transform);
            go.SetActive(false);
            m_timerIds.Add(Timer_Manager.AddTimer(gameObject, () =>
            {
                go.SetActive(true);
                go.GetComponent<Wave_Enemy>()?.StartWave();
            }, m_sequence.m_waveTimes[i]));
        }
    }

    public void OnDestroy()
    {
        m_timerIds.ForEach((x) => { Timer_Manager.CancelTimer(x); });
    }
}
